<template>
  <section id="detailById">
    <h2 class="text-center">
      <span class="text-uppercase">{{ changeHeroName }}</span>
      <span>Details</span>
    </h2>
    <p class="mt-3">{{ `id: ${detailData.id}` }}</p>
    <div class="row mt-4 mb-4">
      <div class="input-group col-md-5">
        <div class="input-group-prepend">
          <span class="input-group-text" id="inputGroup-sizing-default">Name</span>
        </div>
        <input type="text" class="form-control" aria-label="Default" v-model="changeHeroName"
               aria-describedby="inputGroup-default" @keyup.enter="changeHero">
      </div>
    </div>
    <button class="btn btn-outline-dark" @click="$router.go(-1)">Go back</button>
    <button class="btn btn-outline-success ml-3" @click="changeHero">Save</button>
  </section>
</template>

<script>
  import { mapActions } from 'vuex'
  export default {
    name: "detailById",
    data () {
      return {
        changeHeroName: '',
        detailData: ''
      }
    },
    mounted() {
      this.getDetailData()
    },
    methods: {
      ...mapActions({
        addMessages: 'setMessages',
        changeHeroes: 'setHeroes',
      }),
      getDetailData () {
        const vm = this
        vm.detailData = vm.$store.getters['heroes/getHeroes'].find( e => e.id === +vm.$nuxt.$router.app._route.params.id)
        vm.changeHeroName = vm.detailData.name
      },
      changeHero () {
        const vm = this
        const changeHeroesObj = {
          id: vm.detailData.id,
          name: vm.changeHeroName,
          type: 'change'
        }
        if (vm.changeHeroName) {
          vm.addMessages(`updated hero id=${vm.detailData.id}`)
          vm.changeHeroes(changeHeroesObj)
          vm.$router.go(-1)
        }
      }
    }
  }
</script>
